
import matplotlib as mpl
#mpl.use('Agg')
import astropy.units as u
import astropy.constants as const
import numpy
import IPython
import h5py,sys
import matplotlib.pyplot as plt
from matplotlib.colors import LogNorm
from matplotlib import rc
import pylab


rc('font',**{'family':'serif','serif':['Palatino']})
rc('text', usetex=True)
plt.rcParams["xtick.major.size"] = 5
plt.rcParams["ytick.major.size"] = 5

def SetLabels(xsize=18,ysize=18):
    ax = pylab.gca()
    for tick in ax.xaxis.get_major_ticks():
        tick.label1.set_fontsize(xsize)

    for tick in ax.yaxis.get_major_ticks():
        tick.label1.set_fontsize(ysize)


dt = 0.1

G = 1.0
M = 1.0

X0,Y0,Z0 = 0.0,0.0,0.0
X1,Y1,Z1 = 0.0,25.0,0.0

VX0,VY0,VZ0 = 0.0,0.0,0.0
VX1,VY1,VZ1 = 0.0,25.0,0.0


N = 36
Ncircles = 1

Theta = numpy.linspace(0.0,Ncircles*2*numpy.pi, N,endpoint=False)
R = numpy.linspace(2,5.0,N)
R = numpy.zeros(N)+5.0

x = R * numpy.cos(Theta)
y = R * numpy.sin(Theta)
z = numpy.zeros(N)

vtheta = numpy.sqrt(G*M/R)
vr = 0.0

vx = vr * numpy.cos(Theta) - numpy.sin(Theta) * vtheta
vy = vr * numpy.sin(Theta) + numpy.cos(Theta) * vtheta
vz = numpy.zeros(N)






Leapfrog = True

if Leapfrog == True:
    #Force update
    ax = -G*M/(x**2+y**2+z**2)**1.5 * x
    ay = -G*M/(x**2+y**2+z**2)**1.5 * y
    az = -G*M/(x**2+y**2+z**2)**1.5 * z

    #velocity update
    vx = vx - ax*dt/2.0
    vy = vy - ay*dt/2.0
    vz = vz - az*dt/2.0


for Ntimestep in range(1000):
    #Force update
    ax = -G*M/(x**2+y**2+z**2)**1.5 * x
    ay = -G*M/(x**2+y**2+z**2)**1.5 * y
    az = -G*M/(x**2+y**2+z**2)**1.5 * z

    #velocity update
    vx = vx + ax*dt
    vy = vy + ay*dt
    vz = vz + az*dt

    #position update
    x = x + vx*dt
    y = y + vy*dt
    z = z + vz*dt


    if Ntimestep%25==0:
        plt.plot(x,y,'-o')
#        if Leapfrog:
#            plt.quiver(x, y, vx+ax*dt/2.0, vy+ay*dt/2.0, units='width',color='blue')
#        else:
#            plt.quiver(x, y, vx+ax, vy, units='width',color='blue')

#        ax = -G*M/(x**2+y**2+z**2)**1.5 * x
#        ay = -G*M/(x**2+y**2+z**2)**1.5 * y
#        az = -G*M/(x**2+y**2+z**2)**1.5 * z

#        plt.quiver(x, y, ax, ay, units='width',color='red')


        plt.show()

sys.exit()
#IPython.embed()


#plt.figure(1)
#plt.figure(figsize=(15,15))
#plt.subplots_adjust(left=0.15,right=0.96, top=0.92,wspace=0.0, hspace=0.0,bottom=0.15)
#plt.subplot(2,2,1)
#plt.xlabel('$x$',fontsize=16)
#plt.ylabel('$y$',fontsize=16)
#plt.xlim((1.0,3.0))
#plt.ylim((0.0,10.0))
#plt.savefig(sys.argv[0].strip('.py')+'_.png')
#plt.savefig(sys.argv[0].strip('.py')+'_.pdf')
#plt.show()
#plt.clf()
