
import matplotlib as mpl
#mpl.use('Agg')
import numpy
import IPython
import sys
import matplotlib.pyplot as plt
from matplotlib import rc
from mpl_toolkits.mplot3d import Axes3D

dt = 0.025
G = 1.0

#Galaxy 0 point mass
M0 = 1.0

#Galaxy 1 point mass
M1 = 0.33


#Bridge
#VY1 = - 1.4*(  2*G/(X1**2+Y1**2+Z1**2)**0.5/(M0+M1)  )**0.5
#VZ1 = 0.2*VY1
#vtheta = - numpy.sqrt(G*M0/R)#co-rotation

#tails
#VY1 = - 2.2*(  2*G/(X1**2+Y1**2+Z1**2)**0.5/(M0+M1)  )**0.5
#VZ1 = 0.0*VY1
#vtheta =  numpy.sqrt(G*M0/R)#counter-rotation

#Orbit:


#tail
if True:
    M0 = 1.0
    M1 = 0.2

    X0,Y0,Z0 = 0.0,0.0,0.0
    VX0,VY0,VZ0 = 0.0,0.0,0.0

    X0,Y0,Z0 = 0.0,0.0,0.0
    VX0,VY0,VZ0 = 0.0,0.0,0.0

    X1,Y1,Z1 = 7.0, 25.0,0.0
    V_escape = numpy.sqrt(2.0*G*M0/Y1)

    VX1,VY1,VZ1 = 0.0,-1.6*V_escape,0.1*V_escape

    N = 512
    Ncircles = 5

    Theta = numpy.linspace(0.0,Ncircles*2*numpy.pi, N,endpoint=False)
    R = numpy.linspace(1,5.0,N)
    #R = numpy.zeros(N)+4.0

    x = R * numpy.cos(Theta)
    y = R * numpy.sin(Theta)
    z = numpy.zeros(N)

    vtheta = numpy.sqrt(G*M0/R)#counter rotating

    #minor mergers can cause tails. Tails are likely to occur when orbital and disk momentum are not aligned.


#bridge
if True:
    M0 = 1.0
    M1 = 1.0
    X0,Y0,Z0 = 0.0,0.0,0.0
    VX0,VY0,VZ0 = 0.0,0.0,0.0


    X0,Y0,Z0 = 0.0,0.0,0.0
    VX0,VY0,VZ0 = 0.0,0.0,0.0

    X1,Y1,Z1 = 2.0, 25.0,0.0
    V_escape = numpy.sqrt(2.0*G*M0/Y1)

    VX1,VY1,VZ1 = 0.0,-1.2*V_escape,0.1*V_escape

    N = 512
    Ncircles = 5

    Theta = numpy.linspace(0.0,Ncircles*2*numpy.pi, N,endpoint=False)
    R = numpy.linspace(1,5.0,N)
    #R = numpy.zeros(N)+4.0

    x = R * numpy.cos(Theta)
    y = R * numpy.sin(Theta)
    z = numpy.zeros(N)

    vtheta = - numpy.sqrt(G*M0/R)#co-rotation
    #vtheta = numpy.sqrt(G*M0/R)#co-rotation

    #major merger cause bridges

#L = numpy.sqrt(2*rmin*(M0*M1)/(M0+M1) * G * M0 * M1)#rmin is closest approach

#VY1 = - 1.2*(  2*G/(X1**2+Y1**2+Z1**2)**0.5/(M0+M1)  )**0.5
#VZ1 = 0.3*VY1

#disk of galaxy 0:

if False:
    N = 512
    Ncircles = 5

    Theta = numpy.linspace(0.0,Ncircles*2*numpy.pi, N,endpoint=False)
    R = numpy.linspace(1,5.0,N)
    #R = numpy.zeros(N)+4.0

    x = R * numpy.cos(Theta)
    y = R * numpy.sin(Theta)
    z = numpy.zeros(N)

    vtheta = - numpy.sqrt(G*M0/R)#co-rotation
    #vtheta =  numpy.sqrt(G*M0/R)#counter-rotation


vr = 0.0

vx = vr * numpy.cos(Theta) - numpy.sin(Theta) * vtheta
vy = vr * numpy.sin(Theta) + numpy.cos(Theta) * vtheta
vz = numpy.zeros(N)

plt.plot(x,y,'-o',mew=0)
plt.plot(X0,Y0,'o',ms=10,mew=0,color='black')
plt.plot(X1,Y1,'o',ms=10,mew=0,color='red')
plt.xlim((-10,10))
plt.ylim((-10,10))
plt.quiver(x, y, vx, vy, units='width',color='black')
plt.show()




Leapfrog = True

if Leapfrog == True:
    #Force update
    ax = -G*M0/((x-X0)**2+(y-Y0)**2+(z-Z0)**2)**1.5 * (x-X0) - G*M1/((x-X1)**2+(y-Y1)**2+(z-Z1)**2)**1.5 * (x-X1)
    ay = -G*M0/((x-X0)**2+(y-Y0)**2+(z-Z0)**2)**1.5 * (y-Y0) - G*M1/((x-X1)**2+(y-Y1)**2+(z-Z1)**2)**1.5 * (y-Y1)
    az = -G*M0/((x-X0)**2+(y-Y0)**2+(z-Z0)**2)**1.5 * (z-Z0) - G*M1/((x-X1)**2+(y-Y1)**2+(z-Z1)**2)**1.5 * (z-Z1)

    AX0 = - G*M1/((X0-X1)**2+(Y0-Y1)**2+(Z0-Z1)**2)**1.5 * (X0-X1)
    AY0 = - G*M1/((X0-X1)**2+(Y0-Y1)**2+(Z0-Z1)**2)**1.5 * (Y0-Y1)
    AZ0 = - G*M1/((X0-X1)**2+(Y0-Y1)**2+(Z0-Z1)**2)**1.5 * (Z0-Z1)

    AX1 = - G*M0/((X0-X1)**2+(Y0-Y1)**2+(Z0-Z1)**2)**1.5 * (X1-X0)
    AY1 = - G*M0/((X0-X1)**2+(Y0-Y1)**2+(Z0-Z1)**2)**1.5 * (Y1-Y0)
    AZ1 = - G*M0/((X0-X1)**2+(Y0-Y1)**2+(Z0-Z1)**2)**1.5 * (Z1-Z0)
    #IPython.embed()
    #velocity update
    vx = vx - ax*dt/2.0
    vy = vy - ay*dt/2.0
    vz = vz - az*dt/2.0

    VX0 = VX0 - AX0*dt/2.0
    VY0 = VY0 - AY0*dt/2.0
    VZ0 = VZ0 - AZ0*dt/2.0

    VX1 = VX1 - AX1*dt/2.0
    VY1 = VY1 - AY1*dt/2.0
    VZ1 = VZ1 - AZ1*dt/2.0



BeforeFirstPassage = True


Dist_min = ((X0-X1)**2+(Y0-Y1)**2+(Z0-Z1)**2 )**0.5

for Ntimestep in range(5000):

    ax = -G*M0/((x-X0)**2+(y-Y0)**2+(z-Z0)**2)**1.5 * (x-X0) - G*M1/((x-X1)**2+(y-Y1)**2+(z-Z1)**2)**1.5 * (x-X1)
    ay = -G*M0/((x-X0)**2+(y-Y0)**2+(z-Z0)**2)**1.5 * (y-Y0) - G*M1/((x-X1)**2+(y-Y1)**2+(z-Z1)**2)**1.5 * (y-Y1)
    az = -G*M0/((x-X0)**2+(y-Y0)**2+(z-Z0)**2)**1.5 * (z-Z0) - G*M1/((x-X1)**2+(y-Y1)**2+(z-Z1)**2)**1.5 * (z-Z1)

    AX0 = - G*M1/((X0-X1)**2+(Y0-Y1)**2+(Z0-Z1)**2)**1.5 * (X0-X1)
    AY0 = - G*M1/((X0-X1)**2+(Y0-Y1)**2+(Z0-Z1)**2)**1.5 * (Y0-Y1)
    AZ0 = - G*M1/((X0-X1)**2+(Y0-Y1)**2+(Z0-Z1)**2)**1.5 * (Z0-Z1)

    AX1 = - G*M0/((X0-X1)**2+(Y0-Y1)**2+(Z0-Z1)**2)**1.5 * (X1-X0)
    AY1 = - G*M0/((X0-X1)**2+(Y0-Y1)**2+(Z0-Z1)**2)**1.5 * (Y1-Y0)
    AZ1 = - G*M0/((X0-X1)**2+(Y0-Y1)**2+(Z0-Z1)**2)**1.5 * (Z1-Z0)

    #velocity update
    vx = vx + ax*dt
    vy = vy + ay*dt
    vz = vz + az*dt

    VX0 = VX0 + AX0*dt#/2.0
    VY0 = VY0 + AY0*dt#/2.0
    VZ0 = VZ0 + AZ0*dt#/2.0

    VX1 = VX1 + AX1*dt#/2.0
    VY1 = VY1 + AY1*dt#/2.0
    VZ1 = VZ1 + AZ1*dt#/2.0

    #position update
    x = x + vx*dt
    y = y + vy*dt
    z = z + vz*dt

    X0 = X0+VX0*dt
    Y0 = Y0+VY0*dt
    Z0 = Z0+VZ0*dt

    X1 = X1+VX1*dt
    Y1 = Y1+VY1*dt
    Z1 = Z1+VZ1*dt

    if ((X0-X1)**2+(Y0-Y1)**2+(Z0-Z1)**2 )**0.5 < Dist_min:
        Dist_min = ((X0-X1)**2+(Y0-Y1)**2+(Z0-Z1)**2 )**0.5

    if Y1<0:
        BeforeFirstPassage = False

    if Ntimestep %500==0:
        fig = plt.figure(Ntimestep)
        ax = fig.add_subplot(111, projection='3d')
        ax.scatter(x, y, z, c='r',marker='o',zorder=5,s=1)
        ax.scatter(X0, Y0, Z0, c='b',marker='o',zorder=6,s=50)
        ax.scatter(X1, Z1, Z1, c='b',marker='o',zorder=6,s=50)

        ax.set_xlim((-30,30))
        ax.set_ylim((-30,30))
        ax.set_zlim((-30,30))


#        plt.plot(X0,Y0,'o',mew=0,ms=10,color='black')
#        plt.plot(X1,Y1,'o',mew=0,ms=10,color='blue')
        #plt.show()


    #if (X1-X0)**2+(Y1-Y0)**2+(Z1-Z0)**2>15.0**2 and BeforeFirstPassage==False:
    #    break

print 'The minimum Distance of the encounter is', Dist_min

plt.show()
sys.exit()
plt.subplot(1,2,1)
plt.plot(x,y,'o',mew=0,ms=2)
plt.plot(X0,Y0,'o',ms=16,mew=0,color='black')
plt.plot(X1,Y1,'o',ms=10,mew=0,color='red')
plt.xlim((-30,30))
plt.ylim((-40,20))

plt.subplot(1,2,2)
plt.plot(x,z,'o',mew=0,ms=2)
plt.plot(X0,Z0,'o',ms=16,mew=0,color='black')
plt.plot(X1,Z1,'o',ms=10,mew=0,color='red')
plt.xlim((-30,30))
plt.ylim((-30,30))



#if Leapfrog:
    #ax = -G*M0/((x-X0)**2+(y-Y0)**2+(z-Z0)**2)**1.5 * (x-X0) - G*M1/((x-X1)**2+(y-Y1)**2+(z-Z1)**2)**1.5 * (x-X1)
    #ay = -G*M0/((x-X0)**2+(y-Y0)**2+(z-Z0)**2)**1.5 * (y-Y0) - G*M1/((x-X1)**2+(y-Y1)**2+(z-Z1)**2)**1.5 * (y-Y1)
    #az = -G*M0/((x-X0)**2+(y-Y0)**2+(z-Z0)**2)**1.5 * (z-Z0) - G*M1/((x-X1)**2+(y-Y1)**2+(z-Z1)**2)**1.5 * (z-Z1)
    #plt.quiver(x, y, vx+ax*dt/2.0, vy+ay*dt/2.0, units='width',color='black')
plt.show()


fig = plt.figure()
ax = fig.add_subplot(111, projection='3d')

ax.scatter(x, y, z, c='r',marker='o',zorder=5,s=1)
ax.scatter(X0, Y0, Z0, c='b',marker='o',zorder=6,s=50)
ax.scatter(X1, Z1, Z1, c='b',marker='o',zorder=6,s=50)

ax.set_xlim((-30,30))
ax.set_ylim((-30,30))
ax.set_zlim((-30,30))

plt.show()
#        else:
#            plt.quiver(x, y, vx+ax, vy, units='width',color='blue')

#        ax = -G*M/(x**2+y**2+z**2)**1.5 * x
#        ay = -G*M/(x**2+y**2+z**2)**1.5 * y
#        az = -G*M/(x**2+y**2+z**2)**1.5 * z

#        plt.quiver(x, y, ax, ay, units='width',color='red')


sys.exit()



#plt.xlabel('$x$',fontsize=16)
#plt.ylabel('$y$',fontsize=16)
#plt.xlim((1.0,3.0))
#plt.ylim((0.0,10.0))
#plt.savefig(sys.argv[0].strip('.py')+'_.png')
#plt.savefig(sys.argv[0].strip('.py')+'_.pdf')
#plt.show()
#plt.clf()
